﻿package art_apes {
	
	import flash.display.*;
	import flash.text.*;
	import flash.ui.*;
	import flash.utils.*;
	import flash.geom.*;
	import flash.events.*;
	import inconsolata;
	import art_apes.SESSION;
	
	
	public class MANUAL extends Sprite {
		
		var TS = SESSION.ThisSession;
		
		var custom_font:Font = new inconsolata();
		
	    var manual_text_format:TextFormat = new TextFormat(); 
		var manual_text:TextField = new TextField();
		
		public var Messages:Array = new Array();
		
		public var hidden:Boolean = false;
		
		
		public function MANUAL():void{
			
		trace("manual...");
		
		this.mouseChildren = false;
		this.mouseEnabled = false;
		
		
		
		//this.filters = new Array(TS.SessionUI.dropShadow);
		
		graphics.beginFill(0x000000,0.8);
		//graphics.beginGradientFill("linear",[0x000000,0xFFFFFF],[1,0]);
		graphics.drawRect(0,0,445,HEARTWORKS.APPLICATION_HEIGHT);
		graphics.endFill();
		
		addChild(manual_text);
		
		manual_text.width = 405;
		//manual_text.height = HEARTWORKS.APPLICATION_HEIGHT*2;
		//manual_text
		
		manual_text.antiAliasType = flash.text.AntiAliasType.ADVANCED;
		
		manual_text.x = 20;
		manual_text.y = 0;
		
		manual_text.selectable = false;
		//manual_text.embedFonts = true;
		
		manual_text_format.font = custom_font.fontName;
		manual_text_format.size = 12;
		manual_text_format.leading = 4;
		manual_text_format.align = TextFormatAlign.LEFT;
		manual_text.textColor = 0xFFFFFF;
		manual_text.wordWrap = true;
		manual_text.embedFonts = true;
		manual_text.scrollV = true;
		manual_text.defaultTextFormat = manual_text_format;
		manual_text.multiline = true;
		//manual_text.autoSize = TextFieldAutoSize.RIGHT;
		manual_text.condenseWhite = "true";
		
		this.scrollRect = new Rectangle(0,0,HEARTWORKS.APPLICATION_WIDTH,HEARTWORKS.APPLICATION_HEIGHT);
		
		//manual_text.htmlText = Messages[0];
		
		 var style:StyleSheet = new StyleSheet();

            var heading:Object = new Object();
            heading.fontWeight = "bold";
            heading.color = "#ECDCDC";
			heading.fontSize = 24;
			
			var p:Object = new Object();
            p.fontWeight = "normal";
            p.color = "#AAAAAA";
			
			var h2:Object = new Object();
            h2.fontWeight = "normal";
            h2.color = "#CDCDCD";
			h2.fontSize = 20;

           // var body:Object = new Object();
            //body.fontStyle = "italic";

            style.setStyle(".heading", heading);
			style.setStyle("p", p);
			style.setStyle("h2", h2);
           // style.setStyle("body", body);
			
			manual_text.styleSheet = style;			
		
		
var string:String = ( <![CDATA[


	
<br>
<p align="center" class="heading"><font color="#DDDDDD" size="32">the PRBAT Manual</font></p>
<p align="center"><font size="11">MOVE CURSOR TO TOP OR BOTTOM OF SCREEN TO SCROLL</font></p>
<p align="center"><font size="12">PRESS <font color="#1a882c">[7]</font> TO TOGGLE</font></p>

<br>
<br>
<p>
	
	<p>The PRBAT is a drawing application which emphasizes the unique qualities of each user and promotes intuitive and spontaneous processes. 
	Products of proprietary image-making software are often simulacra of traditional media, but the PRBAT produces images which are inherently digital. 
	The controls are structured to extend the human body.</p>
	    
</p><br>

<br><br>


<p>
<p align="center" class="heading">Getting Started</p><br>

<p>Click and drag the mouse to create the surface of a non-rectilinear image.

 If unsatisfied, press <font color="#1062dd">[M]</font> to start over by destroying the surface.

Press <font color="#1062dd">[TAB]</font> to finish the surface.<br><br>

<p>Press <font color="#1a882c">[6]</font> to toggle the control reference window.</p>

</p><br><br><br>


<p>
<p align="center" class="heading">Polygonal Synthesis</p><br>

<p>To detail the surface, synthesize a stamp tool or cut-out tool.</p><br>

<p>Toggle the tool interface by pressing <font color="#1a882c">[CMD / CTRL]</font>. This interface can be dragged around the screen. The top slider controls tool transparency. The second slider controls the overall transparency of polygonal replication.</p><br>

<p>The first two boxes represent stamp tools and the last two boxes represent cut-out tools. Clicking on any of these boxes will enable or disable the tools. This is analogous to pressing <font color="#1a882c">[1]</font> or <font color="#1a882c">[2]</font> for the stamp tools and <font color="#1a882c">[3]</font> or <font color="#1a882c">[4]</font> for the cut-out tools.</p><br>


<h2>Stamp Tools</h2><br>

<p>The stamp tools allow the user to manifest and draw with colored, polygonal forms which anchor themselves to the cursor.</p><br>

<p>Press <font color="#1a882c">[1]</font> or <font color="#1a882c">[2]</font> to enable or disable a stamp tool.</p><br>

<p>Click, drag, and release the mouse to manifest anchorable forms.</p><br>

<p>Hold <font color="#ff00a8">[E]</font> and move the cursor to decrease the opacity of these forms. Release and hold <font color="#ff00a8">[E]</font> again while moving the cursor to increase the transparency. Notice the preview circle below the cursor changes opacity as well.</p><br>

<p>Hold <font color="#1a882c">[SPACE]</font> and move the cursor to select a color for the form. Release <font color="#1a882c">[SPACE]</font> to hide the spectrum. The color spectrum is mapped to a horizontal matrix. It recalls your previously chosen color in relationship to the spectrum's position on screen. This process simplifies the selection of subtle color variations.</p><br>

<p>If unsatisfied, press <font color="#1062dd">[~ / ESC]</font> to reset the tool.</p><br>

<p>Press <font color="#1062dd">[TAB]</font> to anchor these forms to the cursor's position.</p><br>

<p>Click and drag the cursor to make a gesture and mark the surface by polygonal replication. Alternatively, press <font color="#1a882c">[SHIFT]</font> to toggle continuous replication.</p><br>


<h2>Cut-Out Tools</h2><br>

<p>The cut-out tools allow the user to replicate surface data onto manifested forms, which can then be applied back to the surface.</p><br>

<p>Press <font color="#1a882c">[3]</font> or <font color="#1a882c">[4]</font> to enable the cut-out tool.</p><br>

<p>Click, drag, and release the mouse to draw forms. </p><br>

<p>If desired, press <font color="#1062dd">[~ / ESC]</font> to reset the tool. </p><br>

<p>When pleased, move the cursor to a desired anchor position in relationship to the forms. 
Then press <font color="#1062dd">[TAB]</font> to fill these forms with the surface data and anchor them to the cursor.</p><br>

<p>Click and drag the cursor to mark the surface with replications of itself. Alternatively, press <font color="#1a882c">[SHIFT]</font> to toggle continuous replication. </p><br>
</p><br><br>


<p>
<p align="center" class="heading">Tool Manipulation</p><br>

<p>Press and hold <font color="#ff00a8">[Q]</font> while moving the cursor to toggle between increasing or decreasing the size of a tool.</p><br>

<p>Hold <font color="#d66807">[W]</font>, move the cursor, and release <font color="#d66807">[W]</font> to draw a time sensitive motion track for the tool to follow. Tap <font color="#d66807">[W]</font> quickly to cease the motion.</p><br>

<p>Hold <font color="#ff00a8">[E]</font> and move the cursor to decrease a tool's opacity. Release and hold <font color="#ff00a8">[E]</font> again while moving the cursor to increase the transparency.</p><br>

<p>Hold <font color="#d66807">[R]</font> and move the cursor sideways in either direction to rotate the tool. Moving the cursor slowly in a continuous motion will increase the rotation speed. The tool will continue to rotate on it's own if <font color="#d66807">[R]</font> is released at a moderate rotation speed.</p><br>

<p>Press <font color="#1062dd">[5]</font> to reset the above properties of a tool.</p><br>

<p>Press <font color="#1062dd">[~ / ESC]</font> to clear the drawn polygons, and reset a tool.</p><br>

<p>Pressing <font color="#1062dd">[X]</font> while drawing will cancel a gesture's application to the surface.</p>
</p><br><br><br>


<p>
<p align="center" class="heading">Surface Manipulation</p><br>

<p>Hold <font color="#d66807">[A]</font> and move the cursor to pan around the surface.</p><br>

<p>Hold <font color="#d66807">[S]</font>, move the cursor, and release <font color="#d66807">[S]</font> to draw a time sensitive motion track for the surface to follow. Tap <font color="#d66807">[S]</font> quickly to cease the motion.</p><br>

<p>Hold <font color="#ff00a8">[D]</font> and move the cursor to decrease the opacity of a gesture. Release and hold <font color="#ff00a8">[D]</font> again while moving the cursor to increase a gesture's transparency.</p><br>

<p>Hold <font color="#d66807">[F]</font> and move the cursor sideways in either direction to rotate the surface. Moving the cursor slowly in a continuous motion will increase the rotation speed. The surface will continue to rotate on it's own if <font color="#d66807">[F]</font> is released at a moderate rotation speed.</p><br>

<p>Hold <font color="#d66807">[T]</font> and move the cursor up or down to stretch the surface vertically.</p><br>

<p>Hold <font color="#d66807">[G]</font> and move the cursor sideways to stretch the surface horizontally.</p><br>

<p>Press <font color="#1062dd">[H]</font> to reset the position, angle, rotation, and stretch of the surface.</p><br>

<p>Press <font color="#1062dd">[N]</font> to clear the surface, and flood it with the currently chosen color.</p><br>

<p>Press <font color="#1062dd">[J]</font> to change the PRBAT's background color to the currently selected color. A tool must be enabled in order to choose colors.</p>
</p><br><br><br>


<p>
<p align="center" class="heading">Visual Input</p><br>

<p>Press <font color="#1a882c">[/]</font> to toggle the display of a video source. Hold <font color="#d66807">[.]</font> to pan the source. </p><br>

<p>Press  <font color="#1a882c">["]</font> to load and display an image file. Press <font color="#1a882c">["]</font> again to unload the image. Hold <font color="#d66807">[;]</font> to pan the image.</p><br>

<p>These features are useful for synthesizing cut-out tools, making tracings, or selecting colors from the cursor's location by pressing <font color="#1062dd">[C]</font>.</p>
</p><br><br><br>


<p>
<p align="center" class="heading">Saving</p><br>

<p>Press <font color="#1062dd">[RETURN]</font> to save an image. The file is automatically named after it's date of creation and the hexadecimal color of it's working ground.</p>
</p><br><br><br>


<p>
<p align="center" class="heading">Settings</p><br>

<p>Press <font color="#1a882c">[V]</font> to toggle the visual quality of the program. This can be used while drawing to create smooth (anti-aliased) or rough (aliased) edges.</p><br>

<p>Press <font color="#1a882c">[B]</font> to toggle interpolated replication, or line mode (This feature is unavailable while the surface is in motion).</p><br>

<p>Press <font color="#1a882c">[K]</font> to toggle bitmap smoothing (This enhances visual quality at the cost of smoother performance. It is especially effective while the surface is spinning.).</p><br>

</p><br><br><br>







]]> ).toString();
		
manual_text.htmlText = string; 
		
		
addEventListener(Event.ENTER_FRAME,Scroll);		

manual_text.height = manual_text.textHeight;
		
		
		}
		


public function RESIZE(){
			
		graphics.clear();
		graphics.beginFill(0x000000,0.8);
		graphics.drawRect(0,0,445,HEARTWORKS.APPLICATION_HEIGHT);
		graphics.endFill();	
		this.scrollRect = new Rectangle(0,0,HEARTWORKS.APPLICATION_WIDTH,HEARTWORKS.APPLICATION_HEIGHT);	
			
		}


public function Move(event:MouseEvent){

addEventListener(Event.ENTER_FRAME,Scroll);
TS.removeEventListener(MouseEvent.MOUSE_MOVE,Move);

trace("MOVE");

}


var drag:Number = 0.92;
var yVel:Number = 0;
var oldMouse:Number = 0;

public function Scroll(FrameEvent:Event){
	

	
	if(this.visible == true){
	
	trace("M");
	
	if(mouseX < manual_text.width){
	
	if(mouseY > (HEARTWORKS.APPLICATION_HEIGHT-80) && mouseY < (HEARTWORKS.APPLICATION_HEIGHT-5)){
	yVel += (80/(mouseY-HEARTWORKS.APPLICATION_HEIGHT))/4;
	//yVel += 1;
	trace(yVel);
	
	}
	
	if(mouseY < 80 && mouseY > (HEARTWORKS.APPLICATION_HEIGHT-80)){
	//yVel = 0;	
	}
	
	if(mouseY < 80 && mouseY > 5){
	yVel += (80/mouseY)/4;
	//yVel -= 1;
	trace(yVel);
	
	}
	
	}
	
	if(yVel > 50){yVel = 50};
	if(yVel < -50){yVel = -50};
	
	manual_text.y += yVel;
    yVel *= drag;
	
	
	
	
	if(manual_text.y > 0){
	manual_text.y = 0;	
	}
	if(manual_text.y < -manual_text.height+HEARTWORKS.APPLICATION_HEIGHT){
	manual_text.y = -manual_text.height+HEARTWORKS.APPLICATION_HEIGHT;	
	}
	
	
	}
	
	oldMouse = mouseY;
	
}
		
		
	function map(v:Number, a:Number, b:Number, x:Number = 0, y:Number = 1):Number {
    return (v == a) ? x : (v - a) * (y - x) / (b - a) + x;
}
		
		
		//end class and package
		
	}
	
}
